# Remove non UpperCase

def removeNonUpperCase(st):
   upCase = [chr(i) for i in range(ord('A'), ord('Z')+1)]
   return [c for c in st if (c in upCase)]
#  return ''.join([c for c in st if (c in upCase)])

# Nested List Comprehension

xxs = [[1,3,5,2,3,1,2,4,5],[1,2,3,4,5,6,7,8,9],[1,2,4,2,1,6,3,1,3,2,3,6]]

L4 = [[x for x in xs if even(x)] for xs in xxs]

# Maps

def add3(x):
    return x + 3

L5 = map(add3, [1, 5, 3, 1, 6])
list(L5)

L6 = list(map(lambda x: x+3, [1, 5, 3, 1, 6]))

L7 = list(map(lambda s: s+'!', ["BIFF", "BANG", "POW"]))

# Partial Functions

from functools import partial

def power(base, exponent):
    return base ** exponent

square = lambda x: power(x, 2)
cube = lambda x: power(x, 3)

# Partial Functions Example

def rep(x, n):
    return [x for i in range(n)]

def repit(xs):
    rep3 = lambda x: rep(x, 3)
    return map(rep3, xs)

# Another Example with Map

def sqr(x):
    return x*x

def mapSqr(xs):
    return map(sqr, xs)

L = list(map (mapSqr, [[1,2], [3, 4, 5, 6], [7, 8]]))
list(L[1])
             
# Filter

def grt3(x):
    return x>3

L8 = filter(grt3, [1,5,3,2,1,6,4,3,2,1])
L9 = filter(lambda x: x==3, [1,5,3,2,1,6,4,3,2,1])
L10 = filter(even, range(1, 11))

# Reduce

reduce(lambda x, y: x+y, range(1, 101), 0)

reduce(lambda x, y: x*y, range(1, 101), 1)

# Standard Deviation
from math import sqrt
def stdDev(A):
    add = lambda x, y: x+y
    N = float(len(A))
    mu = reduce(add, A, 0)/N
    tot = reduce(add, [(a - mu)**2 for a in A], 0)
    return sqrt(tot/N)

print stdDev([13, 23, 12, 44, 55])

# And Series

def forall(A):
    return reduce(lambda x, y: x and y, A, True)

print forall([True, True, True, True])
print forall([True, True, True, False])

# Contains

def contains(x, xs):
    return reduce(lambda a, b: a or b, [y==x for y in xs], False)

print contains(4, [3, 4, 5, 6, 8])
print contains("happy", adjectives)

def indexSet(x, B):
    return [i for i in range(len(B)) if B[i]==x]




